unit Configure;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFConfigure = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    LabeledEdit3: TLabeledEdit;
    Button4: TButton;
    LabeledEdit4: TLabeledEdit;
    Button5: TButton;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit2Change(Sender: TObject);
    procedure LabeledEdit3Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FConfigure: TFConfigure;

implementation

uses Main;

{$R *.dfm}

procedure TFConfigure.Button1Click(Sender: TObject);
begin
  OpenDialog1.Title:='Select Exomizer file';

  if OpenDialog1.Execute then
   LabeledEdit1.Text:=OpenDialog1.FileName
  else
   LabeledEdit1.Text:=exomizer_path;

end;


procedure TFConfigure.Button2Click(Sender: TObject);
begin
  OpenDialog1.Title:='Select Deflater file';

  if OpenDialog1.Execute then
   LabeledEdit2.Text:=OpenDialog1.FileName
  else
   LabeledEdit2.Text:=deflater_path;

end;


procedure TFConfigure.Button4Click(Sender: TObject);
begin
  OpenDialog1.Title:='Select Mad-Assembler file';

  if OpenDialog1.Execute then
   LabeledEdit3.Text:=OpenDialog1.FileName
  else
   LabeledEdit3.Text:=mads_path;

end;


procedure TFConfigure.Button5Click(Sender: TObject);
begin
  OpenDialog1.Title:='Select LZ4 file';

  if OpenDialog1.Execute then
   LabeledEdit4.Text:=OpenDialog1.FileName
  else
   LabeledEdit4.Text:=lz4_path;

end;


procedure TFConfigure.Button3Click(Sender: TObject);
begin
 if not(FileExists(exomizer_path)) then form1.FileNotFound(exomizer_path, 'Exomizer') else
  if not(FileExists(deflater_path)) then form1.FileNotFound(deflater_path, 'Deflater') else
   if not(FileExists(lz4_path)) then form1.FileNotFound(lz4_path, 'LZ4') else
    if not(FileExists(mads_path)) then form1.FileNotFound(mads_path, 'Mad-Assembler') else
     FConfigure.Close;
end;


procedure TFConfigure.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FConfigure.FormStyle:=fsNormal;

  if not(FileExists(mads_path)) or not(FileExists(deflater_path)) or not(FileExists(exomizer_path)) or not(FileExists(lz4_path)) then form1.Close;
end;


procedure TFConfigure.FormShow(Sender: TObject);
begin
  LabeledEdit1.Text:=exomizer_path;
  LabeledEdit2.Text:=deflater_path;
  LabeledEdit4.Text:=lz4_path;
  LabeledEdit3.Text:=mads_path;
end;


procedure TFConfigure.LabeledEdit1Change(Sender: TObject);
begin
  exomizer_path:=LabeledEdit1.Text;
end;

procedure TFConfigure.LabeledEdit2Change(Sender: TObject);
begin
  deflater_path:=LabeledEdit2.Text;
end;

procedure TFConfigure.LabeledEdit3Change(Sender: TObject);
begin
  mads_path:=LabeledEdit3.Text;
end;

procedure TFConfigure.LabeledEdit4Change(Sender: TObject);
begin
  lz4_path:=LabeledEdit4.Text;
end;

end.
