(*----------------------------------------------------------------------------*)
(* Super Deflater                                                             *)
(* date: 01.09.2011                                                           *)
(* last modified: 24.03.2014                                                  *)
(*----------------------------------------------------------------------------*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, IniFiles,
  Dialogs, ExtCtrls, StdCtrls, Menus, ComCtrls, ShellApi, Buttons, ActnList,
  ToolWin, ShlObj, BMDSpinEdit, hex_counter, hex_counter_check;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ListView1: TListView;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label12: TLabel;
    ComboBox3: TComboBox;
    CheckBox3: TCheckBox;
    ram_enter: TCheckBox;
    MainMenu1: TMainMenu;
    Configure1: TMenuItem;
    ram_exit: TCheckBox;
    About1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ActionList1: TActionList;
    aLoadDos: TAction;
    aLoadData: TAction;
    aSaveAll: TAction;
    aSaveSegment: TAction;
    aPackSegment: TAction;
    aEraseSegment: TAction;
    aAppendSegments: TAction;
    aMoveUp: TAction;
    aMoveDown: TAction;
    aAddRunIni: TAction;
    aClearAll: TAction;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton4: TToolButton;
    ToolButton13: TToolButton;
    aUndo: TAction;
    aRedo: TAction;
    StatusBar1: TStatusBar;
    eRamExit: TBMDSpinEdit;
    eDepack: TFrame1;
    eBuffer: TFrame1;
    eRamEnter: TBMDSpinEdit;
    cruncher: TComboBox;
    eLoadAd: TBMDSpinEdit;
    load_ad: TCheckBox;
    Splitter1: TSplitter;
    eZpVars: TFrame1;
    Splitter2: TSplitter;
    EditSegment: TFrame1;
    procedure Quit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure eBufferChange(Sender: TObject);
    procedure EditSegmentChange(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure eDepackChange(Sender: TObject);
    procedure Configure1Click(Sender: TObject);
    procedure eZpVarsChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FileNotFound(a: string; title: PWideChar);
    procedure ListView1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ram_enterClick(Sender: TObject);
    procedure ram_exitClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure aLoadDosExecute(Sender: TObject);
    procedure aLoadDataExecute(Sender: TObject);
    procedure aSaveAllExecute(Sender: TObject);
    procedure aSaveSegmentExecute(Sender: TObject);
    procedure aPackSegmentExecute(Sender: TObject);
    procedure aEraseSegmentExecute(Sender: TObject);
    procedure aAppendSegmentsExecute(Sender: TObject);
    procedure aMoveUpExecute(Sender: TObject);
    procedure aMoveDownExecute(Sender: TObject);
    procedure aAddRunIniExecute(Sender: TObject);
    procedure aClearAllExecute(Sender: TObject);
    procedure aUndoExecute(Sender: TObject);
    procedure aRedoExecute(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure load_adClick(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure cruncherChange(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;


type
  tbaza = record
           id: integer;
           typ: char;
           ad0: word;
           ad1: word;
           pck: char;
           pad0: word;
           pad1: word;
           del: Boolean;
           len: integer;
           sel: Boolean;
          end;

  abaza = array of tbaza;

  w64  = array [0..$FFFFFF] of byte;


var
  Form1: TForm1;

  tb: abaza;
  buf: w64;

  select_item: integer = -1;

  selected_items: Boolean = false;

  segment_idx, oldClick, undo_idx: integer;

  cur: TPoint;

  exomizer_path, deflater_path, lz4_path, mads_path: string;

  last_path, path, _caption: string;

  cruncher_depack_len, cruncher_buffer_len, cruncher_zpvars_len: integer;

const
  max_len = 256;

  exomizer_depack_len = 173;
  exomizer_buffer_len = 156;
  exomizer_zpvars_len = 8;

  deflater_depack_len = 512;
  deflater_buffer_len = 767;
  deflater_zpvars_len = 9;

  lz4_depack_len = 143;
  lz4_buffer_len = 0;
  lz4_zpvars_len = 0;

  title: string = 'Super Packer v4.6';

  segment: string ='@#seg';

implementation

uses Configure, about;

{$R *.dfm}
//{$I-}


procedure TForm1.Quit1Click(Sender: TObject);
begin
 Close;
end;


procedure show_project;
var i: integer;
    ListItem: TListItem;
begin

 form1.ListView1.Clear;

 for i:=0 to High(tb)-1 do begin

  ListItem := form1.ListView1.Items.Add;

  ListItem.Checked:=tb[i].sel;

  case tb[i].typ of
   'I': begin ListItem.SubItems.Add('INI'); ListItem.SubItems.Add('$'+IntToHex(tb[i].ad0,4)) end;
   'R': begin ListItem.SubItems.Add('RUN'); ListItem.SubItems.Add('$'+IntToHex(tb[i].ad0,4)) end;
  else
   begin

    case tb[i].pck of
     'D','F': ListItem.SubItems.Add('DEF');
         'E': ListItem.SubItems.Add('EXO');
     'L','Z': ListItem.SubItems.Add('LZ4');
    else
     ListItem.SubItems.Add(' ');
    end;

    ListItem.SubItems.Add('$'+IntToHex(tb[i].ad0,4)+' - $'+IntToHex(tb[i].ad1,4));

   end;
  end;

 end;

end;


procedure show_segment;
var i: integer;
begin
 i:=select_item;

 if i>=0 then begin

  form1.EditSegment.BMDSpinEdit1.Enabled:=true;
  form1.EditSegment.BMDSpinEdit1.Text:=IntToHex(tb[i].ad0,4);

  case tb[select_item].typ of
   'I': begin form1.EditSegment.Label1.Visible:=false; form1.ComboBox1.Visible:=true; form1.ComboBox1.ItemIndex:=0 end;
   'R': begin form1.EditSegment.Label1.Visible:=false; form1.ComboBox1.Visible:=true; form1.ComboBox1.ItemIndex:=1 end;
  else
   begin
    form1.EditSegment.Label1.Visible:=true;
    form1.EditSegment.Label1.Caption:='.. $'+IntToHex(tb[i].ad1,4);
    form1.ComboBox1.Visible:=false;
   end;
  end;

 end else
  form1.EditSegment.BMDSpinEdit1.Enabled:=false;

end;


procedure SaveUndo;
var dst, i: integer;
begin

 dst:=FileCreate(path+'undo'+IntToStr(undo_idx));

 FileWrite(dst, select_item, sizeof(select_item));

 for i := 0 to High(tb)-1 do FileWrite(dst, tb[i], sizeof(tb[0]));

 FileClose(dst);

 inc(undo_idx);

end;


procedure ReadUndo;
var src: integer;
    rea, i: integer;
    tmp: abaza;
begin

 if undo_idx>0 then begin

  dec(undo_idx);

  src := FileOpen(path+'undo'+IntToStr(undo_idx), fmOpenRead);
  FileSeek(src, 0,0);

  SetLength(tb, 1);
  SetLength(tmp, 1);

  FileRead(src, select_item, sizeof(select_item));

  while true do begin

   rea:=FileRead(src, tmp[0], sizeof(tmp[0]));

   if rea>0 then begin
    i:=High(tb);

    tb[i]:=tmp[0];

    SetLength(tb, i+2);
   end else
    Break;

  end;

  FileClose(src);

  show_project;
  show_segment;
 end;

end;


function GetSpecialFolderPath(const Folder: Integer): string;
var
  Path: array[0..MAX_PATH] of Char;
begin
  SHGetSpecialFolderPath(0, Path, Folder , False);
  Result := Path;
end;


function GetSegmentFileName: string;
begin
 Result:=path+segment+IntToStr(segment_idx);
end;


procedure checked2sel;
(*----------------------------------------------------------------------------*)
(*  zapisujemy checkboxy w tb[].sel                                           *)
(*----------------------------------------------------------------------------*)
var i: integer;
begin

 selected_items:=false;

 for i:=0 to High(tb)-1 do begin
  tb[i].sel:=form1.ListView1.Items.Item[i].Checked;

  tb[i].del:=false;

  if tb[i].sel then selected_items:=true;  
 end;

end;


procedure EraseSegment;
var i, k: integer;
    tmp: abaza;
begin

  SetLength(tmp, 1);

  for i:=0 to High(tb)-1 do            // DELETE segments
   if tb[i].del then tb[i].sel:=true;


  for i := 0 to High(tb)-1 do
   if not(tb[i].sel) then begin
    k:=High(tmp);
    tmp[k]:=tb[i];

    SetLength(tmp, k+2);
   end;

   tb:=tmp;

   SetLength(tmp, 0);

end;


procedure set_select;
begin

 if select_item>=0 then begin

  if select_item>High(tb)-1 then select_item:=High(tb)-1;

  form1.listview1.Items.Item[select_item].Selected:=true;

  form1.ListView1.Scroll(0, (form1.ListView1.Items[select_item].Top) - cur.y + 8 );

{  form1.ListView1.Scroll(
  0,
  (
  form1.ListView1.Items[2].DisplayRect(drLabel).Top
  -
  form1.ListView1.Items[2].DisplayRect(drLabel).Bottom
  +
  form1.ListView1.Items[2].DisplayRect(drLabel).Top
  )
  ); }
 end;

end;




procedure TForm1.FileNotFound(a: string; title: PWideChar);
var text: PWideChar;
    cnt: string;
begin
  text:=PWideChar('File "'+a+'" not found.');
  Application.MessageBox(text,title,MB_ICONERROR);
end;


procedure SaveSegment(var dst: integer; const i: integer);
var src: integer;
begin

    if tb[i].typ='R' then begin
     buf[0]:=$e0;
     buf[1]:=$02;
     buf[2]:=$e1;
     buf[3]:=$02;
     buf[4]:=tb[i].ad0 and $ff;
     buf[5]:=tb[i].ad0 shr 8;

     FileWrite(dst, buf, 6);
    end else
     if tb[i].typ='I' then begin
      buf[0]:=$e2;
      buf[1]:=$02;
      buf[2]:=$e3;
      buf[3]:=$02;
      buf[4]:=tb[i].ad0 and $ff;
      buf[5]:=tb[i].ad0 shr 8;

      FileWrite(dst, buf, 6);
     end else begin

      buf[0]:=tb[i].ad0 and $ff;
      buf[1]:=tb[i].ad0 shr 8;
      buf[2]:=tb[i].ad1 and $ff;
      buf[3]:=tb[i].ad1 shr 8;

      FileWrite(dst, buf, 4);

      src := FileOpen(path+segment+IntToStr(tb[i].id), fmOpenRead);
      FileSeek(src, 0,0);

      FileRead(src, buf, tb[i].len);
      FileClose(src);

      FileWrite(dst, buf, tb[i].len);
     end;

end;


procedure InsertSegment(var b: abaza; x: integer);
var i, j, k: integer;
    tmp: abaza;
begin

 SetLength(tmp, 1);

 for i := 0 to x do begin
  k:=High(tmp);
  tmp[k]:=tb[i];
  SetLength(tmp, k+2);
 end;

 for j := 0 to High(b)-1 do begin
  k:=High(tmp);
  tmp[k]:=b[j];
  SetLength(tmp, k+2);
 end;

 for i := x+1 to High(tb)-1 do begin
  k:=High(tmp);
  tmp[k]:=tb[i];
  SetLength(tmp, k+2);
 end;

 tb:=tmp;
end;


procedure load_data_file(fnam: string; var tmp: abaza);
var src, dst, len: integer;
begin
   src := FileOpen(fnam, fmOpenRead);
   len := FileSeek(src,0,2);

   if len>$FFFF then begin
    FileClose(src);

    Application.MessageBox('File too long (>$FFFF)','Load data-file',MB_ICONERROR);
    exit;
   end;

   SetLength(tmp, 2);

   tmp[0].typ:=' ';
   tmp[0].ad0:=0;
   tmp[0].ad1:=len-1;
   tmp[0].len:=len;

   FileSeek(src, 0,0);
   FileRead(src, buf, len);

   FileClose(src);

   dst:=FileCreate(GetSegmentFileName);
   FileWrite(dst, buf, len);
   FileClose(dst);

   tmp[0].id:=segment_idx;

   inc(segment_idx);
end;


procedure load_dos_file(fnam: string; var tmp: abaza);
var src, dst, read, len, i: integer;
    x,y: word;
begin

  SetLength(tmp, 1);

  src := FileOpen(fnam, fmOpenRead);
  FileSeek(src,0,0);

  repeat
   read:=FileRead(src, x, 2); if read=0 then Break;

   if x=$ffff then begin
    read:=FileRead(src, x, 2); if read=0 then Break;
   end;

   read:=FileRead(src, y, 2); if read=0 then Break;

   len:=y-x+1;

   read:=FileRead(src, buf, len); if read=0 then Break;

   i:=High(tmp);

   tmp[i].sel:=false;

   tmp[i].id:=-1;
   tmp[i].len:=len;

   if (x=$2e0) and (y=$2e1) then begin
    tmp[i].typ:='R';
    tmp[i].ad0:=buf[0]+buf[1] shl 8;
    tmp[i].ad1:=0;
   end else
    if (x=$2e2) and (y=$2e3) then begin
     tmp[i].typ:='I';
     tmp[i].ad0:=buf[0]+buf[1] shl 8;
     tmp[i].ad1:=0;
    end else begin
     tmp[i].typ:=' ';

     tmp[i].ad0:=x;
     tmp[i].ad1:=y;

     dst:=FileCreate(GetSegmentFileName);
     FileWrite(dst, buf, len);
     FileClose(dst);

     tmp[i].id:=segment_idx;

     inc(segment_idx);
    end;

   SetLength(tmp, i+2);

  until read=0;

  FileClose(src);

end;


procedure TForm1.aMoveUpExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* Move UP                                                                    *)
(*----------------------------------------------------------------------------*)
var b: tbaza;
begin

 if select_item>0 then begin

  SaveUndo;

  b:=tb[select_item-1];
  tb[select_item-1]:=tb[select_item];
  tb[select_item]:=b;

  dec(select_item);

  show_project;

 end;

 ListView1.SetFocus;
 set_select;

end;


procedure TForm1.aMoveDownExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* Move Down                                                                  *)
(*----------------------------------------------------------------------------*)
var b: tbaza;
begin

 if select_item<High(tb)-1 then begin

  SaveUndo;

  b:=tb[select_item+1];
  tb[select_item+1]:=tb[select_item];
  tb[select_item]:=b;

  inc(select_item);

  show_project;

 end;

 ListView1.SetFocus;
 set_select;

end;


procedure TForm1.aLoadDosExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* Load DOS file                                                              *)
(*----------------------------------------------------------------------------*)
var tmp: abaza;
begin

// teraz doczytamy nowy plik DOS FILE
 OpenDialog1.Title:='Load DOS file';

 if OpenDialog1.Execute then begin

  SaveUndo;

  load_dos_file(OpenDialog1.FileName, tmp);

  InsertSegment(tmp, select_item);

  form1.Caption:=title+' - '+OpenDialog1.FileName;

 end;

 show_project;
 show_segment;

 ListView1.SetFocus;
 set_select;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
 FConfigure.Visible:=true;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var INI: TINIFile;
begin

 INI := TINIFile.Create(path+'sp.ini');

 INI.WriteString('last_path','path',OpenDialog1.FileName);

 INI.WriteString('mads','path',mads_path);

 INI.WriteString('exomizer','path',exomizer_path);
 INI.WriteString('deflater','path',deflater_path);
 INI.WriteString('lz4','path',lz4_path);

 INI.WriteString('cruncher','depack',eDepack.BMDSpinEdit1.Text);
 INI.WriteString('cruncher','buffer',eBuffer.BMDSpinEdit1.Text);
 INI.WriteString('cruncher','zp_vars',eZpVars.BMDSpinEdit1.Text);
 INI.WriteString('cruncher','load_addr',eLoadAd.Text);
 INI.WriteInteger('cruncher','load_addr_check',ord(load_ad.Checked));

 INI.WriteString('ram','enter',eRamEnter.Text);
 INI.WriteString('ram','exit',eRamExit.Text);

 INI.WriteInteger('ram','enter_check',ord(ram_enter.Checked));
 INI.WriteInteger('ram','exit_check',ord(ram_exit.Checked));

 INI.WriteInteger('decrunch_effect','check',ord(CheckBox3.Checked));
 INI.WriteInteger('decrunch_effect','mne',ComboBox2.ItemIndex);
 INI.WriteInteger('decrunch_effect','reg',ComboBox3.ItemIndex);

 INI.WriteInteger('cruncher','select',cruncher.ItemIndex);

 INI.free;
end;


procedure defaultCaption;
begin

 form1.Caption:=title+' - Tebe / Madteam (http://madteam.atari8.info)';

end;


procedure TForm1.FormCreate(Sender: TObject);
var INI: TINIFile;
    i: integer;
begin
 doublebuffered:=true;                  //aby nie szarpalo obrazem

 ListView1.DoubleBuffered:=true;

 Application.HintHidePause:=100000;     //aby Hinty nie znikaly zbyt szybko

 FormatSettings.DecimalSeparator := '.';

 // [Current User]\My Documents      CSIDL_PERSONAL
 // All Users\Application Data       CSIDL_COMMON_APPDATA;
 // [User Specific]\Application Data CSIDL_LOCAL_APPDATA;
 // Program Files                    CSIDL_PROGRAM_FILES;
 // All Users\Documents              CSIDL_COMMON_DOCUMENTS;

 path:=GetSpecialFolderPath(CSIDL_APPDATA);            // [USER]/Application Data/
 path:=IncludeTrailingPathDelimiter(path);

 path:=path+'SuperPacker\';
 if not(DirectoryExists(path)) then CreateDir(path);

 OpenDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
 SaveDialog1.InitialDir:=ExtractFilePath(Application.ExeName);

// kasujemy pliki SEG
 i:=0;
 while FileExists(path+segment+IntToStr(i)) do begin
  DeleteFile(path+segment+IntToStr(i));
  inc(i);
 end;

// kasujemy pliki AS8
 i:=0;
 while FileExists(path+segment+IntToStr(i)+'.as8') do begin
  DeleteFile(path+segment+IntToStr(i)+'.as8');
  inc(i);
 end;

// kasujemy pliki PCK
 i:=0;
 while FileExists(path+segment+IntToStr(i)+'.pck') do begin
  DeleteFile(path+segment+IntToStr(i)+'.pck');
  inc(i);
 end;

// kasujemy pliki DAT
 i:=0;
 while FileExists(path+segment+IntToStr(i)+'.dat') do begin
  DeleteFile(path+segment+IntToStr(i)+'.dat');
  inc(i);
 end;


// kasujemy pliki UNDO
 i:=0;
 while FileExists(path+'undo'+IntToStr(i)) do begin
  DeleteFile(path+'undo'+IntToStr(i));
  inc(i);
 end;


 defaultCaption;


// load_ad.Checked:=not(load_ad.Checked);

 INI := TINIFile.Create(path+'sp.ini');

 last_path:=INI.ReadString('last_path','path',path);

 mads_path:=INI.ReadString('mads','path',path+'mads.exe');

 exomizer_path:=INI.ReadString('exomizer','path',path+'exomizer.exe');
 deflater_path:=INI.ReadString('deflater','path',path+'deflater.exe');
 lz4_path:=INI.ReadString('lz4','path',path+'lz4.exe');

 eDepack.BMDSpinEdit1.Text:=INI.ReadString('cruncher','depack','0400');
 eBuffer.BMDSpinEdit1.Text:=INI.ReadString('cruncher','buffer','BC40');
 eZpVars.BMDSpinEdit1.Text:=INI.ReadString('cruncher','zp_vars','F0');
 eLoadAd.Text:=INI.ReadString('cruncher','load_addr','2000');
 load_ad.Checked:=INI.ReadInteger('cruncher','load_addr_check',0) = 1;

 eRamEnter.Text:=INI.ReadString('ram','enter','FE');
 eRamExit.Text:=INI.ReadString('ram','exit','FF');

 ram_enter.Checked:=INI.ReadInteger('ram','enter_check',1) = 1;
 ram_exit.Checked:=INI.ReadInteger('ram','exit_check',1) = 1;

 CheckBox3.Checked:=INI.ReadInteger('decrunch_effect','check',1) = 1;
 i:=INI.ReadInteger('decrunch_effect','mne',0);
 if i>3 then i:=3;
 ComboBox2.ItemIndex:=i;

 i:=INI.ReadInteger('decrunch_effect','reg',4);
 if i>4 then i:=4;
 ComboBox3.ItemIndex:=i;

 cruncher.ItemIndex:=INI.ReadInteger('cruncher','select',0);

 INI.Free;

 cruncherchange(self);

 OpenDialog1.InitialDir:=last_path;
 SaveDialog1.InitialDir:=last_path;

end;


procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var i: integer;
begin

 if Key=#1 then                                  // CTRL+A
  for i:=0 to High(tb)-1 do begin
   tb[i].sel:=true;
   form1.ListView1.Items.Item[i].Checked:=true;
  end;

 if Key=#42 then                                // *
  for i:=0 to High(tb)-1 do begin
   tb[i].sel:=not(tb[i].sel);
   form1.ListView1.Items.Item[i].Checked:=tb[i].sel;
  end;

end;


procedure TForm1.FormShow(Sender: TObject);
begin
 if not(FileExists(mads_path)) or not(FileExists(exomizer_path)) or not(FileExists(deflater_path)) or not(FileExists(lz4_path)) then begin
  FConfigure.Visible:=true;
  FConfigure.Left:=form1.Left;
  FConfigure.Top:=form1.Top;

  FConfigure.FormStyle:=fsStayOnTop;
 end;
end;


procedure SaveRES(a,b:string);
var Res: TResourceStream;
begin
 Res := TResourceStream.Create(hInstance,a,RT_RCDATA); // wyciagnij plik
 Res.SaveToFile(b);                                    // zapisz na dysku
 Res.Free;                                             // zwolnij zmienna
end;


procedure Execute(const _file, _direc, _param: string);
(*----------------------------------------------------------------------------*)
(* http://delphi.about.com/od/windowsshellapi/a/executeprogram.htm            *)
(*----------------------------------------------------------------------------*)
var
   SEInfo: TShellExecuteInfo;
   ExitCode: DWORD;
begin
   form1.Caption:='Please wait...';

   FillChar(SEInfo, SizeOf(SEInfo), 0) ;
   SEInfo.cbSize := SizeOf(TShellExecuteInfo) ;

   with SEInfo do begin
     fMask := SEE_MASK_NOCLOSEPROCESS;
     Wnd := Application.Handle;
     lpFile := PChar(_file) ;

     lpParameters := PChar(_param) ;   // ParamString can contain the application parameters

     if _direc<>'' then
     lpDirectory := PChar(_direc) ;    // StartInString specifies the name of the working directory.
                                       // If ommited, the current directory is used.
   end;

   if ShellExecuteEx(@SEInfo) then begin
     repeat
       Application.ProcessMessages;

       GetExitCodeProcess(SEInfo.hProcess, ExitCode) ;
     until (ExitCode <> STILL_ACTIVE) or Application.Terminated;
   end;

end;


procedure exomizer2;
var i, src, dst: integer;
    bat: textfile;
    fnam, fdst, loa: string;
begin

 SaveRES ('EXOMIZE', path+'exomize.as8');

 assignfile(bat, path+'exomize.as8'); append(bat);

 writeln(bat,'.macro'#9'enter_hook');
 if form1.ram_enter.Checked then begin
  writeln(bat, #9'sei');
  writeln(bat, #9'mva #$',form1.eRamEnter.Text,' $d301');
  writeln(bat, #9'mva #0 $d40e');
 end;
 writeln(bat,'.endm');

 writeln(bat,'.macro'#9'exit_hook');
 if form1.ram_exit.Checked then begin
  writeln(bat, #9'mva #$',form1.eRamExit.Text,' $d301');
  writeln(bat, #9'mva #$40 $d40e');
  writeln(bat, #9'cli');
 end;
 writeln(bat, #9'rts');
 writeln(bat,'.endm');

 writeln(bat,'.macro'#9'effect_hook');
 if form1.CheckBox3.Checked then begin
  writeln(bat, #9,form1.ComboBox2.Text+' '+form1.ComboBox3.Text);
 end;
 writeln(bat,'.endm');

 flush(bat);
 closefile(bat);


  _caption:=form1.Caption;
  form1.Enabled:=false;

 (*-- zapiszemy segmenty do kolejnych plikow --*)

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin

   fnam:=segment+IntToStr(i)+'.dat';

   src := FileOpen(path+segment+IntToStr(tb[i].id), fmOpenRead);
   FileSeek(src, 0,0);
   FileRead(src, buf[6], tb[i].len);
   FileClose(src);

   buf[0]:=$ff;
   buf[1]:=$ff;
   buf[2]:=tb[i].ad0 and $ff;
   buf[3]:=tb[i].ad0 shr 8;
   buf[4]:=tb[i].ad1 and $ff;
   buf[5]:=tb[i].ad1 shr 8;

   dst := FileCreate(path+fnam);
   FileWrite(dst, buf, tb[i].len + 6);
   FileClose(dst);

   if form1.load_ad.Checked then
    loa:=form1.eLoadAd.Text
   else
    loa:=IntToHex(buf[2]+buf[3] shl 8,4);

   fdst:=ChangeFileExt(fnam, '.obx');

   Execute(exomizer_path, '', 'mem -c "'+path+fnam+'" -o "'+path+'@@exo.pck"');

   Execute(mads_path, '', '"'+path+'exomize.as8" -o:"'+path+fdst+'" -d:i_load_addr=$'+loa+' -d:i_table_addr=$'+form1.eBuffer.BMDSpinEdit1.Text+' -d:i_zp_addr=$'+form1.eZpVars.BMDSpinEdit1.Text+' -d:i_depack_addr=$'+form1.eDepack.BMDSpinEdit1.Text);

//   DeleteFile(path+fnam);
  end;

//  DeleteFile(path+'exomize.as8');
//  DeleteFile(path+'@@exo.pck');

  form1.Enabled:=true;
  form1.Caption:=_caption;

end;


procedure TForm1.aPackSegmentExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Pack segment                                                              *)
(*----------------------------------------------------------------------------*)
var i, j, f, g: integer;
    fnam, fasm, fobx, cnt: string;
    as8: textfile;
    ptyp: char;
    text: PWideChar;
    ok: Boolean;
    tmp: abaza;
    str: array of string;
    label skip, stop;
begin

 checked2sel;

 SaveUndo;

 // segmenty nie spelniajace warunku dlugosci odznaczamy
 for i:=0 to High(tb)-1 do
  if (tb[i].len-2<max_len) or (tb[i].typ<>' ') then tb[i].sel:=false;

 // odswiezamy wyglad listy
 show_project;

 // sprawdzamy czy mamy jakies zaznaczenie
 ok:=false;
 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin
   ok:=true;

   f:=eDepack.BMDSpinEdit1.Position;
   g:=f+cruncher_depack_len;

   if not(((tb[i].ad0<f) and (tb[i].ad1<f)) or ((tb[i].ad0>g) and (tb[i].ad1>g))) then begin

    text:=PWideChar('Access violations at address:'#13#10#13#10'Depacker $'+IntToHex(f,4)+'..$'+IntToHex(g,4)+' -> Segment $'+IntToHex(tb[i].ad0,4)+'..$'+IntToHex(tb[i].ad1,4));
    Application.MessageBox(text,'Pack segment',MB_ICONERROR);

    ok:=false;
    Break;
   end;


   if cruncher.ItemIndex<2 then begin

    f:=eBuffer.BMDSpinEdit1.Position;
    g:=f+cruncher_buffer_len;

    if not(((tb[i].ad0<f) and (tb[i].ad1<f)) or ((tb[i].ad0>g) and (tb[i].ad1>g))) then begin

     text:=PWideChar('Access violations at address:'#13#10#13#10'Buffer $'+IntToHex(f,4)+'..$'+IntToHex(g,4)+' -> Segment $'+IntToHex(tb[i].ad0,4)+'..$'+IntToHex(tb[i].ad1,4));
     Application.MessageBox(text,'Pack segment',MB_ICONERROR);

     ok:=false;
     Break;
    end;

   end;

  end;


 if not(ok) then goto stop;


 if not(FileExists(mads_path)) then begin
  FileNotFound(mads_path, 'Mad-Assembler');
  exit;
 end;


 case cruncher.ItemIndex of

  0: begin

      if not(FileExists(exomizer_path)) then begin
        FileNotFound(exomizer_path, 'Exomizer');
        exit;
      end;

      ptyp:='E';

      exomizer2;
      goto skip;
     end;

  1: begin

      if not(FileExists(deflater_path)) then begin
       FileNotFound(deflater_path, 'Deflater');
       exit;
      end;

      SaveRES ('INFLATE', path+'inflate.as8');

      ptyp:='D';
     end;

  2: begin

      if not(FileExists(lz4_path)) then begin
       FileNotFound(deflater_path, 'LZ4');
       exit;
      end;

      SaveRES ('LZ4', path+'unlz4.as8');

      ptyp:='L';
     end;

 end;


  _caption:=form1.Caption;
  form1.Enabled:=false;

 (*-- zapiszemy segmenty do kolejnych plikow --*)

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin

   fnam:=segment+IntToStr(i)+'.pck';

   if ptyp='D' then
    Execute(deflater_path, '', '"'+path+segment+IntToStr(tb[i].id)+'" "'+path+fnam+'"')
   else
    Execute(lz4_path, '', '-9 -f "'+path+segment+IntToStr(tb[i].id)+'" "'+path+fnam+'"');

  end;

  form1.Enabled:=true;
  form1.Caption:=_caption;


  val('$'+eDepack.BMDSpinEdit1.Text, i, j);
  eDepack.BMDSpinEdit1.Text:=IntToHex(i and $ffff,4);

  val('$'+eBuffer.BMDSpinEdit1.Text, i, j);
  eBuffer.BMDSpinEdit1.Text:=IntToHex(i and $ffff,4);

  val('$'+eZpVars.BMDSpinEdit1.Text, i, j);
  eZpVars.BMDSpinEdit1.Text:=IntToHex(i and $ff,4);

  val('$'+eLoadAd.Text, i, j);
  eLoadAd.Text:=IntToHex(i and $ffff,4);


 //------------------------------------------
 //-- zapis plikow DEFLATER AS8
 //------------------------------------------

 _caption:=form1.Caption;
 form1.Enabled:=false;

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin

   fnam:=segment+IntToStr(i)+'.pck';

   f := FileOpen(path+fnam, fmOpenRead);
   j := FileSeek(f,0,2);
   FileClose(f);

   case ptyp of
    'D': inc(j,16);
    'L': inc(j,5);
   end;

   fasm:=ChangeFileExt(fnam, '.as8');
   fobx:=ChangeFileExt(fnam, '.obx');

   assignfile(as8, path+fasm); rewrite(as8);

   if ptyp='D' then
    writeln(as8, #9'icl "inflate.as8"'#13#10)
   else
    writeln(as8, #9'icl "unlz4.as8"'#13#10);

   if load_ad.Checked then
    writeln(as8, #9'org $',eLoadAd.Text)
   else
    writeln(as8, #9'org $',IntToHex(tb[i].ad1-j,4));

   writeln(as8,'main');

   writeln(as8, #9'mwa #src'#9'inputPointer');
   writeln(as8, #9'mwa #$',IntToHex(tb[i].ad0,4),#9'outputPointer');

   if ptyp='L' then
    writeln(as8, #9'jmp unlz4'#13#10)
   else
    writeln(as8, #9'jmp inflate'#13#10);


   if ptyp='L' then
    writeln(as8, 'src'#9'ins "',path,fnam,'",$b,.FILESIZE "',path,fnam,'"-$0b-$06',#13#10)
   else
    writeln(as8, 'src'#9'ins "',path,fnam,'"',#13#10);


   writeln(as8, #9'ini main',#13#10);

   writeln(as8, '.macro'#9'decrunch_effect');
   if CheckBox3.Checked then writeln(as8, #9,form1.ComboBox2.Text,' ',form1.ComboBox3.Text);
   writeln(as8, '.endm');

   flush(as8);
   closefile(as8);

   if ptyp='D' then
    Execute(mads_path, '', '"'+path+fasm+'" -o:"'+path+fobx+'" -d:INFLATE=$'+eDepack.BMDSpinEdit1.Text+' -d:INFLATE_DATA=$'+eBuffer.BMDSpinEdit1.Text+' -d:INFLATE_ZP=$'+eZpVars.BMDSpinEdit1.Text+' -d:RAM_ENTER='+IntToStr(eRamEnter.Position*ord(ram_enter.Checked))+' -d:RAM_EXIT='+IntToStr(eRamExit.Position*ord(ram_exit.Checked)) )
   else
    Execute(mads_path, '', '"'+path+fasm+'" -o:"'+path+fobx+'" -d:UNLZ4=$'+eDepack.BMDSpinEdit1.Text+' -d:RAM_ENTER='+IntToStr(eRamEnter.Position*ord(ram_enter.Checked))+' -d:RAM_EXIT='+IntToStr(eRamExit.Position*ord(ram_exit.Checked)) );

//   DeleteFile(path+fnam);
//   DeleteFile(path+fasm);
 end;

// DeleteFile(path+'inflate.as8');

 form1.Enabled:=true;
 form1.Caption:=_caption;


skip:

 // nazwy plikow na podstawie kolejnosci zaznaczenia

 SetLength(str, 1);

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin
   j:=High(str);

   str[j]:=segment+IntToStr(i)+'.obx';

   SetLength(str, j+2);
  end;

 // podstawiamy spakowane pliki

 for j:=0 to High(str)-1 do

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin           // przepisz segmenty

   fnam:=str[j];

   if not(FileExists(path+fnam)) then begin
    FileNotFound(path+fnam, 'Append packed data');

    show_segment;

    goto stop;
   end;

   tb[i].del:=true;
   tb[i].sel:=false;

   load_dos_file(path+fnam, tmp);

   case ptyp of
   'D': begin
         tmp[0].pck:='F';
         tmp[1].pck:=ptyp;

         tmp[1].pad0:=tb[i].ad0;
         tmp[1].pad1:=tb[i].ad1;
        end;

   'E': begin
         tmp[0].pck:=ptyp;

         tmp[0].pad0:=tb[i].ad0;
         tmp[0].pad1:=tb[i].ad1;

         tmp[1].typ:='I';
        end;

   'L': begin
         tmp[0].pck:='Z';
         tmp[1].pck:=ptyp;

         tmp[1].pad0:=tb[i].ad0;
         tmp[1].pad1:=tb[i].ad1;

        end;

   end;

   InsertSegment(tmp, i);              // wstawiamy nowe segmenty

//   DeleteFile(path+fnam);

   Break;
  end;

 EraseSegment;

 show_project;
 show_segment;

stop:

 form1.ListView1.SetFocus;
 set_select;

end;


procedure TForm1.ListView1Click(Sender: TObject);
var i: integer;
begin
 i:=ListView1.ItemIndex;

 checked2sel;

 if i>=0 then begin
  select_item:=i;

  show_segment;
 end else
  ListView1.Hint:='';

end;


procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin

 if tb[Item.Index].typ in ['I','R'] then
  ListView1.Canvas.Brush.Color:=clMoneyGreen
 else
  ListView1.Canvas.Brush.Color:=clWindow;

end;


procedure TForm1.ListView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i: integer;
begin

 if X>18 then
 if Button=mbRight then begin
  i:=ListView1.ItemIndex;

  if i>=0 then begin
   listview1.Items.Item[i].Checked:=not(listview1.Items.Item[i].Checked);
   tb[i].sel:=listview1.Items.Item[i].Checked;

   checked2sel;

   select_item:=i;

   show_project;

   show_segment;

   set_select;
  end;

 end;
end;


procedure TForm1.ListView1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i, newClick, w: integer;
    s: string;
begin
 cur:=Point(x,y);

 if ListView1.Items.Count>0 then begin

  i:=abs(
  form1.ListView1.Items[0].DisplayRect(drLabel).Top
  -
  form1.ListView1.Items[0].DisplayRect(drLabel).Bottom
  +
  form1.ListView1.Items[0].DisplayRect(drLabel).Top);

  newClick:=y div i+listview1.TopItem.Index;

  if newClick < High(tb) then begin
   s:='Segment: '+IntToStr(newClick+1)+' / '+IntToStr(ListView1.Items.Count)+' - ';


   case tb[newClick].typ of
    'I': s:=S+'$02E2 .. $02E3 - INI $'+IntToHex(tb[newClick].ad0,4);
    'R': s:=S+'$02E0 .. $02E1 - RUN $'+IntToHex(tb[newClick].ad0,4);
   else
    s:=s+'$'+IntToHex(tb[newClick].ad0,4)+' .. $'+IntToHex(tb[newClick].ad1,4);
   end;

   if tb[newClick].pck in ['D','E','L'] then begin

    case tb[newClick].pck of
     'D': s:=s+' - DEFLATE';
     'E': s:=s+' - EXOMIZE';
     'L': s:=s+' - LZ4';
    end;

    s:=s+' -> $'+IntToHex(tb[newClick].pad0,4)+' .. $'+IntToHex(tb[newClick].pad1,4);
   end;

   if tb[newClick].pck='F' then s:=s+' - INFLATER';
   if tb[newClick].pck='Z' then s:=s+' - LZ4 DEPACKER';

   w:=StatusBar1.Canvas.TextWidth(s);

   StatusBar1.Panels[0].Width:=(StatusBar1.Width-w+32) div 2;
   StatusBar1.Panels[1].Text:=s;

  end;

 end;


end;


procedure TForm1.aLoadDataExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Load data-file                                                            *)
(*----------------------------------------------------------------------------*)
var tmp: abaza;
begin

// teraz doczytamy nowy plik DATA-FILE
  OpenDialog1.Title:='Load data-file';

  if OpenDialog1.Execute then begin

   SaveUndo;

   load_data_file(OpenDialog1.FileName, tmp);

   InsertSegment(tmp, select_item);

   form1.Caption:=title+' - '+OpenDialog1.FileName;

  end;

 show_project;
 show_segment;

 form1.ListView1.SetFocus;
 set_select;
end;


procedure TForm1.aSaveAllExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Save file                                                                 *)
(*----------------------------------------------------------------------------*)
var i, dst: integer;
begin

 if ListView1.Items.Count=0 then exit;


 checked2sel;
 show_project;

 SaveDialog1.Title:='Save file';

 if SaveDialog1.Execute then begin

  dst := FileCreate(SaveDialog1.FileName);

  buf[0]:=$ff;
  buf[1]:=$ff;

  FileWrite(dst, buf, 2);

  for i := 0 to High(tb)-1 do SaveSegment(dst, i);

  FileClose(dst);

 end;

 ListView1.SetFocus;
 set_select;
end;


procedure TForm1.aSaveSegmentExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Save segment                                                              *)
(*----------------------------------------------------------------------------*)
var i, dst: integer;
    fnam, a: string;
begin

 checked2sel;
 show_project;

 if not(selected_items) then exit;


 SaveDialog1.Title:='Save segment';

 if SaveDialog1.Execute then begin

  fnam:=SaveDialog1.FileName;

  for i:=0 to High(tb)-1 do
   if tb[i].sel then begin

    a:=ExtractFileName(fnam)+'_'+IntToStr(i)+'.dat';

    dst := FileCreate(ExtractFilePath(fnam)+a);

    SaveSegment(dst, i);

    FileClose(dst);

   end;

 end;

 form1.ListView1.SetFocus;
 set_select;
end;


procedure TForm1.aClearAllExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Clear ALL !                                                               *)
(*----------------------------------------------------------------------------*)
begin
 if ListView1.Items.Count>0 then
 if Application.MessageBox('Are you sure ?','Clear ALL !',mb_YESNO+MB_ICONQUESTION)=6 then begin

  select_item:=-1;
  SetLength(tb, 1);

  EditSegment.BMDSpinEdit1.Text:='';
  EditSegment.BMDSpinEdit1.Enabled:=false;

  EditSegment.Label1.Caption:='';

  ComboBox1.Visible:=false;

  StatusBar1.Panels[0].Width:=0;

  show_project;

  form1.ListView1.Refresh;

  defaultCaption;
 end;

end;


procedure TForm1.About1Click(Sender: TObject);
begin
 AboutBox.ShowModal;
end;


procedure TForm1.aAddRunIniExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Add RUN, INIT                                                             *)
(*----------------------------------------------------------------------------*)
var tmp: abaza;
begin

 SaveUndo;

 SetLength(tmp, 2);

 tmp[0].id:=-1;
 tmp[0].typ:='R';
 tmp[0].ad0:=0;
 tmp[0].ad1:=0;

 InsertSegment(tmp, select_item);

 show_project;
 show_segment;

 form1.ListView1.SetFocus;
 set_select;

 SetLength(tmp, 0);
end;


procedure TForm1.aEraseSegmentExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Erase segment                                                             *)
(*----------------------------------------------------------------------------*)
begin

 checked2sel;
 show_project;

 if not(selected_items) then exit;


 if Application.MessageBox('Are you sure ?','Erase segment',mb_YESNO+MB_ICONQUESTION)=6 then begin

  SaveUndo;
  
  EraseSegment;

 end;

 if select_item>High(tb)-1 then select_item:=High(tb)-1;

 show_project;
 show_segment;

 form1.ListView1.SetFocus;
 set_select;

end;


procedure TForm1.aAppendSegmentsExecute(Sender: TObject);
(*----------------------------------------------------------------------------*)
(*  Append segments                                                           *)
(*----------------------------------------------------------------------------*)
var i, j, min, max, _first, src, dst: integer;
    ok: Boolean;
    tmp: abaza;
    range: array of record
                     ad0,ad1: integer;
                    end;
    label stop;
begin

 checked2sel;

 SaveUndo;

 // segmenty nie spelniajace warunku dlugosci odznaczamy
 for i:=0 to High(tb)-1 do
  if tb[i].typ<>' ' then tb[i].sel:=false;

 // odswiezamy wyglad listy
 show_project;

 // sprawdzamy czy mamy jakies zaznaczenie
 SetLength(range, 1);
 ok:=false;
 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin
   ok:=true;

   j:=High(range);

   range[j].ad0:=tb[i].ad0;
   range[j].ad1:=tb[i].ad1;

   SetLength(range, j+2);
  end;

 if not(ok) or (High(range)=1) then goto stop;


 for j := 0 to High(range)-1 do
  for i := 0 to High(range)-1 do
   if i<>j then
    if not(((range[i].ad0<range[j].ad0) and (range[i].ad1<range[j].ad0)) or ((range[i].ad0>range[j].ad1) and (range[i].ad1>range[j].ad1))) then begin

     Application.MessageBox('Segments overlap','Append segments',MB_ICONERROR);

     goto stop;
    end;


 min:=$1ffff;
 max:=-1;
 _first:=-1;              // od _FIRST wstawimy nowy segment

 fillchar(buf, sizeof(buf), 0);

 for i:=0 to High(tb)-1 do
  if tb[i].sel then begin

   if _first=-1 then _first:=i;

   src:=FileOpen(path+segment+IntToStr(tb[i].id), fmOpenRead);
   FileSeek(src, 0,0);

   FileRead(src, buf[tb[i].ad0], tb[i].len);
   FileClose(src);

   if tb[i].ad0<min then min:=tb[i].ad0;
   if tb[i].ad1>max then max:=tb[i].ad1;

  end;

 EraseSegment;


 SetLength(tmp, 2);

 tmp[0].typ:=' ';

 tmp[0].ad0:=min;
 tmp[0].ad1:=max;

 j:=max-min+1;

 tmp[0].len:=j;

 dst:=FileCreate(GetSegmentFileName);
 FileWrite(dst, buf[min], j);
 FileClose(dst);

 tmp[0].id:=segment_idx;

 inc(segment_idx);


 select_item:=_first;


 InsertSegment(tmp, select_item-1);

 SetLength(tmp, 0);


 if select_item>High(tb)-1 then select_item:=High(tb)-1;


 show_project;
 show_segment;

stop:

 form1.ListView1.SetFocus;
 set_select;

end;


procedure TForm1.eDepackChange(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* depacker                                                                   *)
(*----------------------------------------------------------------------------*)
begin
 if eDepack.BMDSpinEdit1.Position+cruncher_depack_len>$FFFF then
  eDepack.BMDSpinEdit1.Position:=$FFFF-cruncher_depack_len;

 eDepack.Label1.Caption:='.. $'+IntToHex((eDepack.BMDSpinEdit1.Position+cruncher_depack_len) and $ffff, 4);
end;


procedure TForm1.eBufferChange(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* buffer                                                                     *)
(*----------------------------------------------------------------------------*)
begin
 if eBuffer.BMDSpinEdit1.Position+cruncher_buffer_len>$FFFF then
  eBuffer.BMDSpinEdit1.Position:=$FFFF-cruncher_buffer_len;

 eBuffer.Label1.Caption:='.. $'+IntToHex((eBuffer.BMDSpinEdit1.Position+cruncher_buffer_len) and $ffff, 4);
end;


procedure TForm1.eZpVarsChange(Sender: TObject);
(*----------------------------------------------------------------------------*)
(* exomizer zp_vars                                                           *)
(*----------------------------------------------------------------------------*)
begin
 if eZpVars.BMDSpinEdit1.Position+cruncher_zpvars_len>$FF then
  eZpVars.BMDSpinEdit1.Position:=$FF-cruncher_zpvars_len;

 eZpVars.Label1.Caption:='.. $'+IntToHex((eZpVars.BMDSpinEdit1.Position+cruncher_zpvars_len) and $ff, 4);
end;


procedure TForm1.EditSegmentChange(Sender: TObject);
var j: integer;
begin

 if select_item>=0 then begin

  if tb[select_item].typ<>' ' then
   tb[select_item].ad0 := EditSegment.BMDSpinEdit1.Position
  else begin
   j:=tb[select_item].ad1-tb[select_item].ad0;
   tb[select_item].ad0 := EditSegment.BMDSpinEdit1.Position;
   tb[select_item].ad1:=tb[select_item].ad0+j;
  end;

  show_project;

  case tb[select_item].typ of
   'I': begin form1.ComboBox1.Visible:=true; form1.ComboBox1.ItemIndex:=0 end;
   'R': begin form1.ComboBox1.Visible:=true; form1.ComboBox1.ItemIndex:=1 end;
  else
   begin
    form1.EditSegment.Label1.Caption:='.. $'+IntToHex(tb[select_item].ad1,4);
    form1.ComboBox1.Visible:=false;
   end;
  end;

  set_select;
 end;

end;


procedure TForm1.ComboBox1Change(Sender: TObject);
begin

 if select_item>=0 then begin

  case ComboBox1.ItemIndex of
   0: tb[select_item].typ:='I';
   1: tb[select_item].typ:='R';
  end;

  show_project;

  set_select;
 end;

end;


procedure TForm1.Configure1Click(Sender: TObject);
begin
 FConfigure.visible:=true;
end;


procedure TForm1.cruncherChange(Sender: TObject);
var renter, rexit, efect: integer;
begin

 eBuffer.Visible:=true;
 eZpVars.Visible:=true;

 renter:=ord(ram_enter.Checked)*11;
 rexit:=ord(ram_exit.Checked)*11;
 efect:=ord(checkbox3.Checked)*3;

 case cruncher.ItemIndex of
  0: begin
      cruncher_depack_len := exomizer_depack_len+renter+rexit+efect;
      cruncher_buffer_len := exomizer_buffer_len;
      cruncher_zpvars_len := exomizer_zpvars_len;
     end;

  1: begin
      cruncher_depack_len := deflater_depack_len+renter+rexit+efect;
      cruncher_buffer_len := deflater_buffer_len;
      cruncher_zpvars_len := deflater_zpvars_len;
     end;

  2: begin
      cruncher_depack_len := lz4_depack_len+renter+rexit+efect;
      cruncher_buffer_len := lz4_buffer_len;
      cruncher_zpvars_len := lz4_zpvars_len;

      eBuffer.Visible:=false;
      eZpVars.Visible:=false;
     end;
 end;


 eDepackChange(self);
 eBufferChange(self);
 eZpVarsChange(self);
end;


procedure TForm1.load_adClick(Sender: TObject);
// load_addr
begin
 eLoadAd.Enabled:=load_ad.Checked;
end;

procedure TForm1.ram_enterClick(Sender: TObject);
// ram_enter
begin
 eRamEnter.Enabled:=ram_enter.Checked;

 cruncherChange(self);
end;

procedure TForm1.ram_exitClick(Sender: TObject);
// ram_exit
begin
 eRamExit.Enabled:=ram_exit.Checked;

 cruncherChange(self);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
// decrunch_effect_code
begin
 Label12.Enabled:=CheckBox3.Checked;
 ComboBox2.Enabled:=CheckBox3.Checked;
 ComboBox3.Enabled:=CheckBox3.Checked;

 cruncherChange(self);
end;


procedure TForm1.aUndoExecute(Sender: TObject);
begin
 SaveUndo;

 dec(undo_idx);

 ReadUndo;

 aRedo.Enabled:=true;
end;


procedure TForm1.aRedoExecute(Sender: TObject);
begin

 if FileExists(path+'undo'+IntToStr(undo_idx+1)) then begin

  inc(undo_idx,2);
  ReadUndo;

 end;

end;

end.

